function condition = my_cond( what, x )
%my_cond( what, x ): Sinartisi pou epistrefei tin deikti katastasi ton 6
%                    provlimaton pou perigrafontai apo tin ekfonisi. An
%                    thesete what = 1 tote epistrefete o deiktis
%                    katastaseis tis f1 gia to analogo x pou thesate an
%                    valete what = 2 tis f2, what = 3 tis Willkinson, what
%                    = 4 tis Grcar, kai outo kathekseis... mexri to 6.

if what==1
    f1 = ( 1 - cos( x ) ) / x^2;
    %i paragogos tou f1 einai i f1_par
    f1_par = ( x * sin( x ) - 2 * ( 1 - cos( x ) ) ) / x^3;
    condition=abs( x * f1_par / f1 );
elseif what==2
    f2 = 2 * ( sin( x / 2 ) )^2 / x^2;
    %i paragogos tou f2 einai i f2_par
    f2_par = ( 2 * sin ( x / 2 ) * cos( x / 2 ) * x - 4 * ( sin( x / 2 ) )^2 ) / x^3;
    condition= abs(x * f2_par / f2);
elseif what==3
    n = 13;
    p_willkinson = poly( 1:n-1 );
    if is_root(p_willkinson,x)==1
        p_par_willkinson = polyder( p_willkinson );
        condition = 0;
        for i = 1:1:n-1
            condition = condition + abs(p_willkinson(i) * x^i);
        end
        condition = condition / abs( x * polyval(p_par_willkinson, x) );
    else
        condition = 0;
        p_willkinson_x_abs = abs( polyval( p_willkinson, x ) );
        for i = 1:1:n
            condition = condition + abs(p_willkinson(i) * x^i) / p_willkinson_x_abs;
        end
    end
elseif what==4
    n = 13;
    p_grcar = poly(eig(gallery('grcar',12)));
    if is_root(p_grcar,x)==1
        p_par_grcar = polyder( p_grcar );
        condition = 0;
        for i = 1:1:n-1
            condition = condition + abs(p_grcar(i) * x^i);
        end
        condition = condition / abs( x * polyval(p_par_grcar, x) );
    else
        condition = 0;
        p_grcar_x_abs = abs( polyval( p_grcar, x ) );
        for i = 1:1:n
            condition = condition + abs(p_grcar(i) * x^i) / p_grcar_x_abs;
        end
    end
elseif what==5
    W=[ones(9,1),x',(x.^2)',(x.^3)',(x.^4)',(x.^5)',(x.^6)',(x.^7)',(x.^8)'];
    condition=cond(W);
elseif what==6
    W=[ones(9,1),x',(x.^2)',(x.^3)',(x.^4)',(x.^5)',(x.^6)',(x.^7)',(x.^8)'];
    condition=cond(W);
else
    'I timi tou what den itan orthi. Gia tin akriveia:'
    help my_cond
end
end