function A = QR(A)
% QR is a function that QR-factorize with Householder a matrix A and
% returns its factorization.

% find the size of the A matrix
size_A = size(A);
% m is the mumber of rows of A matrix
m = size_A(1, 1);
% n is the number of columns of A matrix
n = size_A(1, 2);

for j = 1: n
    u(j : m) = REFL( A(j : m, j) );
    
    A(j : m, j : n) = REFLROW(A(j : m, j : n), u(j : m)');
    
    if j < m
        A(j + 1 : m, j) = u(j + 1 : m)';
    end
end