function X = askisi_1_2(A, b)
% askisi_1_2 is a function that takes as arguments the matrixes A and b and
% returns the solution of the problem that minimize the ||A*X - b||(F)
% (Forbenius norm)

% find the size of the A matrix
size_A = size(A);
% m is the mumber of rows of A matrix
m = size_A(1, 1);
% n is the number of columns of A matrix
n = size_A(1, 2);

% find the size of the b matrix
size_b = size(b);
% s is the number of columns of b matrix
s = size_b(1, 2);

% QR factorization of matrix A 
A = QR(A);

% find the U matrix and the R matrix
[Q,R,U] = find_Q_R_U(A);


for i = 1: s
    temp = b(:,i);
    for j = 1: n
        temp(j : m, 1) = REFLROW( temp(j : m, 1), U(j : m,j) );
    end

    X(:,i) = R(1 : n, 1 : n) \ temp(1 : n, 1);
end

end