function [Q, R, U] = find_Q_R_U(A)
% find_Q_R_U is a function that takes as an argument that QR-factorized A
% matrix and returns the R, Q and U matrixes.

% find the size of the A matrix
size_A = size(A);
% m is the mumber of rows of A matrix
m = size_A(1, 1);
% n is the number of columns of A matrix
n = size_A(1, 2);

% the R matrix is the up-triangular part of A 
R = A;

% we zero the down-triangular part of R (== A) matrix
for i = 1: m
    for j = 1: n
        if i > j
            R(i, j) = 0;
        end
    end
end

% the U matrix is the down-triangular part of A with ones in its diagonal
U = A - R + eye(m, n);

% I is a matrix with ones
I = eye(m, m);

% in this part we find the Q matrix by processing the U matrix
Q = I - 2 * U(:, 1) * U(:, 1)' / (U(:, 1)' * U(:, 1));

for i = 2: n
    H = I - 2 * U(:, i) * U(:, i)' / (U(:, i)' * U(:, i));
    Q = Q * H;
end

end