function [prf_QR, prf_reversed_QR, prf_askisi_1_2] = prove(A)
%function that is used to prove the rightness of the algorithms QR,
%reversed_QR and askisi_1_2

% proving the QR function
A_qr = QR(A);
[Q,R,U] = find_Q_R_U(A_qr);
prf_QR = norm(A - Q*R, 'fro');

% proving the reversed_QR function
A_computed = reversed_QR(A_qr);
prf_reversed_QR = norm(A - A_computed, 'fro');


% proving the askisi_1_2 function

% find the size of the A matrix
size_A = size(A);

% m is the mumber of rows of A matrix
m = size_A(1, 1);

B = rand(m);
X = askisi_1_2(A,B);
prf_askisi_1_2 = abs(norm(B - A*X, 'fro') - norm(B - A * (A \ B), 'fro'));

end