function B = reversed_QR(A)
% reversed_QR is the "reversed" function of QR. It takes the QR-factorized
% A matrix and returns it without being QR factorized processed.

% find the size of the A matrix
size_A = size(A);
% m is the mumber of rows of A matrix
m = size_A(1, 1);
% n is the number of columns of A matrix
n = size_A(1, 2);

% the R matrix is the up-triangular part of A 
R = A;

% we zero the down-triangular part of R (== A) matrix
for i = 1: m
    for j = 1: n
        if i > j
            R(i, j) = 0;
        end
    end
end

% find the A matrix without the QR factorization process, by using the
% reflrow for the multiplications in order to make less multiplies.
B = REFLROW(R, [ zeros(n-1,1) ; 1 ; A(n+1:m,n) ] );

for i = n-1 : -1 : 1
    u = [ zeros(i-1, 1) ; 1 ; A(i+1:m, i) ];
    B = REFLROW(B, u);
end

end